
/* This file is part of MetaDOM
 * a generic bind package for the Document Object Model API.
 * Copyright (C) 2001  Luca Padovani <luca.padovani@cs.unibo.it>
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * For more information, please visit the author's home page
 * http://www.cs.unibo.it/~lpadovan
 * or send an email to <luca.padovani@cs.unibo.it>
 *
 * DO NOT EDIT: this file has been generated automatically by MetaDOM
 */

#include <gdome.h>


#include "GdomeSmartDOMBasic.hh"
#include "GdomeSmartDOMDOMImplementation.hh"
#include "GdomeSmartDOMCore.hh"
#include "GdomeSmartDOMEvents.hh"

namespace GdomeSmartDOM {

Document::Document(GdomeDocument* obj) : Node((GdomeNode*) obj) { }

Document::Document(const Document& obj) : Node(obj) { }

Document::Document(const Node& obj) : Node((GdomeNode*) gdome_cast_doc(obj.gdome_obj)) { }

Document& Document::operator=(const Document& obj)
{
  if (gdome_obj == obj.gdome_obj) return *this;

  if (gdome_obj != 0) {
    GdomeException exc_ = 0;
    gdome_doc_unref((GdomeDocument*) gdome_obj, &exc_);
    if (exc_ != 0) throw DOMException(exc_, "unref to Document failed");
  }

  gdome_obj = obj.gdome_obj;

  if (gdome_obj != 0) {
    GdomeException exc_ = 0;
    gdome_doc_ref((GdomeDocument*) gdome_obj, &exc_);
    if (exc_ != 0) throw DOMException(exc_, "ref to Document failed");
  }

  return *this;
}

Document::~Document()
{
}

DocumentType Document::get_doctype() const
{
  GdomeException exc_ = 0;
  GdomeDocumentType* res__ = gdome_doc_doctype((GdomeDocument*) gdome_obj, &exc_);
  if (exc_ != 0) throw DOMException(exc_, "Document::get_doctype");
  DocumentType res_(res__);
  if (res__ != 0) gdome_dt_unref(res__, &exc_);
  if (exc_ != 0) throw DOMException(exc_, "unref to DocumentType failed");
  return res_;
}

DOMImplementation Document::get_implementation() const
{
  GdomeException exc_ = 0;
  GdomeDOMImplementation* res__ = gdome_doc_implementation((GdomeDocument*) gdome_obj, &exc_);
  if (exc_ != 0) throw DOMException(exc_, "Document::get_implementation");
  DOMImplementation res_(res__);
  if (res__ != 0) gdome_di_unref(res__, &exc_);
  if (exc_ != 0) throw DOMException(exc_, "unref to DOMImplementation failed");
  return res_;
}

Element Document::get_documentElement() const
{
  GdomeException exc_ = 0;
  GdomeElement* res__ = gdome_doc_documentElement((GdomeDocument*) gdome_obj, &exc_);
  if (exc_ != 0) throw DOMException(exc_, "Document::get_documentElement");
  Element res_(res__);
  if (res__ != 0) gdome_el_unref(res__, &exc_);
  if (exc_ != 0) throw DOMException(exc_, "unref to Element failed");
  return res_;
}

Element Document::createElement(const GdomeString& tagName) const
{
  GdomeException exc_ = 0;
  GdomeElement* res__ = gdome_doc_createElement((GdomeDocument*) gdome_obj, static_cast<GdomeDOMString*>(tagName), &exc_);
  if (exc_ != 0) throw DOMException(exc_, "Document::createElement");
  Element res_(res__);
  if (res__ != 0) gdome_el_unref(res__, &exc_);
  if (exc_ != 0) throw DOMException(exc_, "unref to Element failed");
  return res_;
}

DocumentFragment Document::createDocumentFragment() const
{
  GdomeException exc_ = 0;
  GdomeDocumentFragment* res__ = gdome_doc_createDocumentFragment((GdomeDocument*) gdome_obj, &exc_);
  if (exc_ != 0) throw DOMException(exc_, "Document::createDocumentFragment");
  DocumentFragment res_(res__);
  if (res__ != 0) gdome_df_unref(res__, &exc_);
  if (exc_ != 0) throw DOMException(exc_, "unref to DocumentFragment failed");
  return res_;
}

Text Document::createTextNode(const GdomeString& data) const
{
  GdomeException exc_ = 0;
  GdomeText* res__ = gdome_doc_createTextNode((GdomeDocument*) gdome_obj, static_cast<GdomeDOMString*>(data), &exc_);
  if (exc_ != 0) throw DOMException(exc_, "Document::createTextNode");
  Text res_(res__);
  if (res__ != 0) gdome_t_unref(res__, &exc_);
  if (exc_ != 0) throw DOMException(exc_, "unref to Text failed");
  return res_;
}

Comment Document::createComment(const GdomeString& data) const
{
  GdomeException exc_ = 0;
  GdomeComment* res__ = gdome_doc_createComment((GdomeDocument*) gdome_obj, static_cast<GdomeDOMString*>(data), &exc_);
  if (exc_ != 0) throw DOMException(exc_, "Document::createComment");
  Comment res_(res__);
  if (res__ != 0) gdome_c_unref(res__, &exc_);
  if (exc_ != 0) throw DOMException(exc_, "unref to Comment failed");
  return res_;
}

CDATASection Document::createCDATASection(const GdomeString& data) const
{
  GdomeException exc_ = 0;
  GdomeCDATASection* res__ = gdome_doc_createCDATASection((GdomeDocument*) gdome_obj, static_cast<GdomeDOMString*>(data), &exc_);
  if (exc_ != 0) throw DOMException(exc_, "Document::createCDATASection");
  CDATASection res_(res__);
  if (res__ != 0) gdome_cds_unref(res__, &exc_);
  if (exc_ != 0) throw DOMException(exc_, "unref to CDATASection failed");
  return res_;
}

ProcessingInstruction Document::createProcessingInstruction(const GdomeString& target, const GdomeString& data) const
{
  GdomeException exc_ = 0;
  GdomeProcessingInstruction* res__ = gdome_doc_createProcessingInstruction((GdomeDocument*) gdome_obj, static_cast<GdomeDOMString*>(target), static_cast<GdomeDOMString*>(data), &exc_);
  if (exc_ != 0) throw DOMException(exc_, "Document::createProcessingInstruction");
  ProcessingInstruction res_(res__);
  if (res__ != 0) gdome_pi_unref(res__, &exc_);
  if (exc_ != 0) throw DOMException(exc_, "unref to ProcessingInstruction failed");
  return res_;
}

Attr Document::createAttribute(const GdomeString& name) const
{
  GdomeException exc_ = 0;
  GdomeAttr* res__ = gdome_doc_createAttribute((GdomeDocument*) gdome_obj, static_cast<GdomeDOMString*>(name), &exc_);
  if (exc_ != 0) throw DOMException(exc_, "Document::createAttribute");
  Attr res_(res__);
  if (res__ != 0) gdome_a_unref(res__, &exc_);
  if (exc_ != 0) throw DOMException(exc_, "unref to Attr failed");
  return res_;
}

EntityReference Document::createEntityReference(const GdomeString& name) const
{
  GdomeException exc_ = 0;
  GdomeEntityReference* res__ = gdome_doc_createEntityReference((GdomeDocument*) gdome_obj, static_cast<GdomeDOMString*>(name), &exc_);
  if (exc_ != 0) throw DOMException(exc_, "Document::createEntityReference");
  EntityReference res_(res__);
  if (res__ != 0) gdome_er_unref(res__, &exc_);
  if (exc_ != 0) throw DOMException(exc_, "unref to EntityReference failed");
  return res_;
}

NodeList Document::getElementsByTagName(const GdomeString& tagname) const
{
  GdomeException exc_ = 0;
  GdomeNodeList* res__ = gdome_doc_getElementsByTagName((GdomeDocument*) gdome_obj, static_cast<GdomeDOMString*>(tagname), &exc_);
  if (exc_ != 0) throw DOMException(exc_, "Document::getElementsByTagName");
  NodeList res_(res__);
  if (res__ != 0) gdome_nl_unref(res__, &exc_);
  if (exc_ != 0) throw DOMException(exc_, "unref to NodeList failed");
  return res_;
}

Node Document::importNode(const Node& importedNode, const bool deep) const
{
  GdomeException exc_ = 0;
  GdomeNode* res__ = gdome_doc_importNode((GdomeDocument*) gdome_obj, (GdomeNode*) importedNode.gdome_obj, deep, &exc_);
  if (exc_ != 0) throw DOMException(exc_, "Document::importNode");
  Node res_(res__);
  if (res__ != 0) gdome_n_unref(res__, &exc_);
  if (exc_ != 0) throw DOMException(exc_, "unref to Node failed");
  return res_;
}

Element Document::createElementNS(const GdomeString& namespaceURI, const GdomeString& qualifiedName) const
{
  GdomeException exc_ = 0;
  GdomeElement* res__ = gdome_doc_createElementNS((GdomeDocument*) gdome_obj, static_cast<GdomeDOMString*>(namespaceURI), static_cast<GdomeDOMString*>(qualifiedName), &exc_);
  if (exc_ != 0) throw DOMException(exc_, "Document::createElementNS");
  Element res_(res__);
  if (res__ != 0) gdome_el_unref(res__, &exc_);
  if (exc_ != 0) throw DOMException(exc_, "unref to Element failed");
  return res_;
}

Attr Document::createAttributeNS(const GdomeString& namespaceURI, const GdomeString& qualifiedName) const
{
  GdomeException exc_ = 0;
  GdomeAttr* res__ = gdome_doc_createAttributeNS((GdomeDocument*) gdome_obj, static_cast<GdomeDOMString*>(namespaceURI), static_cast<GdomeDOMString*>(qualifiedName), &exc_);
  if (exc_ != 0) throw DOMException(exc_, "Document::createAttributeNS");
  Attr res_(res__);
  if (res__ != 0) gdome_a_unref(res__, &exc_);
  if (exc_ != 0) throw DOMException(exc_, "unref to Attr failed");
  return res_;
}

NodeList Document::getElementsByTagNameNS(const GdomeString& namespaceURI, const GdomeString& localName) const
{
  GdomeException exc_ = 0;
  GdomeNodeList* res__ = gdome_doc_getElementsByTagNameNS((GdomeDocument*) gdome_obj, static_cast<GdomeDOMString*>(namespaceURI), static_cast<GdomeDOMString*>(localName), &exc_);
  if (exc_ != 0) throw DOMException(exc_, "Document::getElementsByTagNameNS");
  NodeList res_(res__);
  if (res__ != 0) gdome_nl_unref(res__, &exc_);
  if (exc_ != 0) throw DOMException(exc_, "unref to NodeList failed");
  return res_;
}

Element Document::getElementById(const GdomeString& elementId) const
{
  GdomeException exc_ = 0;
  GdomeElement* res__ = gdome_doc_getElementById((GdomeDocument*) gdome_obj, static_cast<GdomeDOMString*>(elementId), &exc_);
  if (exc_ != 0) throw DOMException(exc_, "Document::getElementById");
  Element res_(res__);
  if (res__ != 0) gdome_el_unref(res__, &exc_);
  if (exc_ != 0) throw DOMException(exc_, "unref to Element failed");
  return res_;
}



}

